<?php

namespace STM\Match\Referee;

use STM\StmFactory;

/**
 * Test class for MatchRefereeValidator.
 * Generated by PHPUnit on 2012-07-10 at 14:10:23.
 * @group match_referee
 */
class MatchRefereeValidatorTest extends \PHPUnit_Framework_TestCase {

    private $match;
    private $match_referees;

    protected function setUp() {
        $this->match = StmFactory::find()->Match->findById (5);
        $this->match_referees = $this->match ? StmFactory::find()->MatchReferee->findByMatch($this->match) : array();
        MatchRefereeValidator::init();
    }

    public function testCheck_create() {
        // invalid values
        $match = StmFactory::find()->Match->findById (1);
        $person = StmFactory::find()->Person->findById(1);
        $position = StmFactory::find()->PersonPosition->findById(1);
        $this->assert_bad_arguments('checkCreate', null);
        $this->assert_bad_arguments('checkCreate', array('match' => $match, 'position' => $position, 'person' => null));
        $this->assert_bad_arguments('checkCreate', array('match' => $match, 'position' => null, 'person' => null));
        $this->assert_bad_arguments('checkCreate', array('match' => null, 'position' => $position, 'person' => $person));
    }

    public function testCheck_position() {        
        foreach ($this->match_referees as $referee) {
            MatchRefereeValidator::setMatchReferee($referee);                        
            $this->assert_bad_arguments('checkPosition', null);
            $this->assert_bad_arguments('checkPosition', array());
            $this->assert_bad_arguments('checkPosition', StmFactory::find()->PersonPosition->findById($referee->getIdPosition()));
            MatchRefereeValidator::resetMatchReferee();
        }
    }

    private function assert_bad_arguments($method, $data) {
        MatchRefereeValidator::init();
        parent::assertFalse(MatchRefereeValidator::$method($data));
        MatchRefereeValidator::init();
    }


}

?>
